/****************************************************
 Statistics Online Computational Resource (SOCR)
 http://www.StatisticsResource.org
  
 All SOCR programs, materials, tools and resources are developed by and freely disseminated to the entire community.
 Users may revise, extend, redistribute, modify under the terms of the Lesser GNU General Public License
 as published by the Open Source Initiative http://opensource.org/licenses/. All efforts should be made to develop and distribute
 factually correct, useful, portable and extensible resource all available in all digital formats for free over the Internet.
  
 SOCR resources are distributed in the hope that they will be useful, but without
 any warranty; without any explicit, implicit or implied warranty for merchantability or
 fitness for a particular purpose. See the GNU Lesser General Public License for
 more details see http://opensource.org/licenses/lgpl-license.php.
  
 http://www.SOCR.ucla.edu
 http://wiki.stat.ucla.edu/socr
  It s Online, Therefore, It Exists! 
 ****************************************************/
package edu.ucla.stat.SOCR.TG_distributome.data;

import java.net.URL;
import java.util.StringTokenizer;

public class SOCRReference{
	public int id; 
	public int author_count;
	public String[] authors;
	public String authorString;
	public String year;
	public String title;
	public String journal;
	public String volumeInfo;
	public String url;
	public boolean showID = false; // used  by editor
	public boolean debug = false;
	// constructor
	public SOCRReference() {

	}
	
	public void setId(String _id){
		id = Integer.parseInt(_id);
	}
	public void setAuthor(String aString){
		authorString = aString;
		StringTokenizer tk2 = new StringTokenizer(aString,",");
		author_count= tk2.countTokens();
		authors = new String[author_count];
		int i = 0;
		while(tk2.hasMoreTokens()){
			authors[i]= tk2.nextToken().trim();
			i++;
		}
	}
	public void setYear(String y){
		year =y;
	}
	public void setTitle(String t){
		title = t;
	}
	public void setJournal(String j){
		journal = j;
	}
	public String getJournal(){
		return journal;
	}
	public void setVolumnInfo(String v){
		volumeInfo = v;
	}
	public String  getVolumnInfo(){
		return volumeInfo;
	}
	public void setURL(String u){
		url  = u;
	}
	public  String  getURL(){
		return url;
	}
	public int  getId(){
		return id;
	}
	
	public String getAuthorString(){
		return authorString;
	}
	
	public String getYear(){
		return year;
	}
	public String getTitle(){
		return title;
	}
	public void print(){
		System.out.println(toString());
	}
	
	public String toString(){
	
		String refString ="";
		for (int a = 0; a<author_count-1; a++)
			refString+=authors[a]+", ";
		
		refString += authors[author_count-1]+"; ";
		
		refString += title+"; ";
		
		refString += journal+"; ";
		refString += year+"; ";
		refString += volumeInfo;
		
		if(debug)
			System.out.println(id+" "+refString);
			
		if(showID)
			return (id+" "+refString);
		else
			return refString;
		
	}

	
}

